"""ControlWindow widgets"""

import BBox
import BStringView

from InterfaceKit import *

from modules.constants import *

class ConnectionBox(BBox.BBox):
	def __init__(self, rect):
		BBox.BBox.__init__(self, rect, 'connbox', B_FULL_UPDATE_ON_RESIZE|B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW, B_FANCY_BORDER)
		self.SetLabel('Connection')
		w = self.StringWidth('Resource') + 5
		label = BStringView.BStringView((5,15,0,0), 'jidlabel','JID:', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		label = BStringView.BStringView((w,15,0,0), 'jid','', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		lframe = label.Frame()
		label = BStringView.BStringView((5,lframe[3]+2,0,0), 'resourcelabel','Resource:', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		label = BStringView.BStringView((w,lframe[3]+2,0,0), 'resource','', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		lframe = label.Frame()
		label = BStringView.BStringView((5,lframe[3]+2,0,0), 'ssllabel','Secure:', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		label = BStringView.BStringView((w,lframe[3]+2,0,0), 'ssl','', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		lframe = label.Frame()
		self.ResizeTo(rect[2]-5,lframe[3]+5)

	def setJID(self, jid):
		label = self.FindView('jid')
		label.SetText(jid)
		label.ResizeToPreferred()

	def setResource(self, text):
		label = self.FindView('resource')
		label.SetText(text)
		label.ResizeToPreferred()

	def setSSL(self, state):
		label = self.FindView('ssl')
		if state:
			text = 'Yes'
		elif state is None:
			text = ''
		else:
			text = 'No'
		label.SetText(text)
		label.ResizeToPreferred()

###
class PresenceBox(BBox.BBox):
	def __init__(self,rect):
		BBox.BBox.__init__(self, rect, 'prsbox', B_FULL_UPDATE_ON_RESIZE|B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW, B_FANCY_BORDER)
		self.SetLabel('Presence')
		w = self.StringWidth('Resource') + 5
		label = BStringView.BStringView((5,15,0,0), 'showlabel','Show:', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		label = BStringView.BStringView((w,15,0,0), 'show','', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		lframe = label.Frame()
		label = BStringView.BStringView((5,lframe[3]+2,0,0), 'statuslabel','Status:', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		label = BStringView.BStringView((w,lframe[3]+2,0,0), 'status','', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		lframe = label.Frame()
		label = BStringView.BStringView((5,lframe[3]+2,0,0), 'prioritylabel','Priority:', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		label = BStringView.BStringView((w,lframe[3]+2,0,0), 'priority','', B_FOLLOW_NONE)
		label.ResizeToPreferred()
		self.AddChild(label)
		lframe = label.Frame()
		self.ResizeTo(rect[2]-5,lframe[3] + 5)

	def setShow(self, text):
		label = self.FindView('show')
		label.SetText(text)
		label.ResizeToPreferred()

	def setStatus(self, text):
		label = self.FindView('status')
		label.SetText(text)
		label.ResizeToPreferred()

	def setPriority(self, prio):
		label = self.FindView('priority')
		label.SetText(prio)
		label.ResizeToPreferred()
