""" Main """

import BTextView
import BTextControl
import BBox
import BStringView
import BButton
import BMessage
import BMenuBar
import BMenuItem
import BPopUpMenu
import BNode

from InterfaceKit import *
from SupportKit import *

from modules.constants import *
from constants import *
import modules.people

class MessageView(BTextView.BTextView):
	def __init__(self, rect):
		textrect = (1, 1, rect[2] - 1, rect[3] - 1)
		BTextView.BTextView.__init__(self, rect, 'MessageText', textrect,
			B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
		self.MakeEditable(False)

	def FrameResized(self, width, height):
		self.SetTextRect((1, 1, width - 1, height - 1))


class ViewBox(BBox.BBox):
	def __init__(self, rect, jid=None, subject=None, date=None, mode='view'):
		BBox.BBox.__init__(self,rect, 'controlbox', B_FOLLOW_LEFT_RIGHT, 
			B_FULL_UPDATE_ON_RESIZE|B_WILL_DRAW, B_PLAIN_BORDER)
		bounds = self.Bounds()
		if mode == 'view' or mode == 'reply' or (mode == 'new' and jid is not None):
			if mode == 'view':
				jidctl = BTextControl.BTextControl((2,2,bounds[2]-2,20),'jidctl', 'From',jid,None,
					B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW|B_NAVIGABLE)
			else:
				jidctl = BTextControl.BTextControl((2,2,bounds[2]-2,20),'jidctl', 'To',jid,None,
					B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW|B_NAVIGABLE)
			(w,h) = jidctl.GetPreferredSize()
			jidctl.ResizeTo(bounds[2]-2,h)
			if mode == 'view' or mode == 'new':
				jidctl.SetEnabled(False)
			else:
				jidctl.SetEnabled(False)
			self.AddChild(jidctl)
			wframe = jidctl.Frame()
		else:
			jidlabel = BStringView.BStringView((2,2,0,0), 'jidlabel','To', B_FOLLOW_NONE, B_WILL_DRAW)
			jidlabel.ResizeToPreferred()
			self.AddChild(jidlabel)
			jidctl = JIDMenu((2,2,bounds[2]-2,20), modules.people.getJIDs())
			(w,h) = jidctl.GetPreferredSize()
			jidctl.ResizeTo(bounds[2]-2,h)
			self.AddChild(jidctl)
			wframe = jidctl.Frame()
		subjectctl = BTextControl.BTextControl((2,wframe[3]+5,bounds[2]-2,20),'subjectctl',
			'Subject',subject,None, B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW|B_NAVIGABLE)
		subjectctl.SetDivider(55.0)
		if mode == 'view':
			subjectctl.SetEnabled(False)
		bmsg = BMessage.BMessage(SUBJECT_CHANGED)
		subjectctl.SetModificationMessage(bmsg)
		(w,h) = subjectctl.GetPreferredSize()
		subjectctl.ResizeTo(bounds[2]-2,h)
		self.AddChild(subjectctl)
		div = subjectctl.StringWidth('Subject')
		subjectctl.SetDivider(div+5)
		if mode == 'view' or mode == 'reply' or (mode == 'new' and jid is not None):
			jidctl.SetDivider(div+5)
		else:
			jidframe = jidctl.Frame()
			jidctl.MoveTo(div+5,2)
		wframe = subjectctl.Frame()
		if mode == 'view':
			btn = BButton.BButton((2,wframe[3] + 2,0,0), 'replybtn', 'Reply', BMessage.BMessage(REPLY_TO_MESSAGE))
			btn.ResizeToPreferred()
			self.AddChild(btn)
			wframe = btn.Frame()
			btn = BButton.BButton((wframe[2] + 5,wframe[1],0,0), 'trashbtn', 'Trash It', BMessage.BMessage(TRASH_MESSAGE))
			wframe = btn.Frame()
			btn.ResizeToPreferred()
			self.AddChild(btn)
		if mode == 'new' or mode == 'reply':
			btn = BButton.BButton((2,wframe[3] + 2,0,0), 'sendbtn', 'Send', BMessage.BMessage(SEND_MESSAGE))
			btn.ResizeToPreferred()
			self.AddChild(btn)
			if mode == 'new' and jid is None:
				btn.SetEnabled(False)
			wframe = btn.Frame()
		self.ResizeTo(bounds[2], wframe[3] + 5)

	def getJID(self):
		view = self.FindView('jidctl')
		if isinstance(view, JIDMenu):
			menuitem = view.ItemAt(0)
			jid = view.popup.getJID(menuitem.Label())
			return jid
		else:
			return view.Text()
	def getSubject(self):
		view = self.FindView('subjectctl')
		return view.Text()

class SubjectControl(BTextControl.BTextControl):
	def __init__(self, rect, text):
		BTextControl.BTextControl.__init__(self, rect,'subject', 'Subject',text,None, B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW)

class JIDMenu(BMenuBar.BMenuBar):
		def __init__(self, rect, jids):
			BMenuBar.BMenuBar.__init__(self, rect,'jidctl', B_FOLLOW_NONE)
			self.popup = MyPopupMenu('Select Contact')
			for jid in jids:
				bmsg = BMessage.BMessage(CONTACT_SELECTED)
				bmsg.AddString('jid', jid)
				# get display name
				bentry = modules.people.getEntryForJID(jid)
				bnode = BNode.BNode(bentry)
				attrinfo = bnode.GetAttrInfo('META:name')
				name = bnode.ReadAttr('META:name',0,0,attrinfo[1]-1)
				# create bmenuitem
				item = JIDMenuItem('%s (%s)' % (name, jid), jid, bmsg)
				self.popup.AddItem(item)
			self.AddItem(self.popup)


class JIDMenuItem(BMenuItem.BMenuItem):
	def __init__(self, label, jid, bmsg):
		BMenuItem.BMenuItem.__init__(self, label, bmsg)
		self.jid = jid

class MyPopupMenu(BPopUpMenu.BPopUpMenu):
	def __init__ (self, name):
		BPopUpMenu.BPopUpMenu.__init__(self, name)
		self.itemdict = {}

	def AddItem(self, item):
		self.itemdict[item.Label()] = item.jid
		BPopUpMenu.BPopUpMenu.AddItem(self, item)

	def getJID(self, name):
		return self.itemdict[name]
