"""Export contacts to local filsystem"""
import os

import BQuery
import BAlert
import BNode
import BEntry
import BFile
import BNodeInfo

from InterfaceKit import *
from StorageKit import *
from SupportKit import *

import modules.people

def export(name, jid, dir):
	fpath = os.path.join(dir,name)
	if not os.path.exists(fpath):
		bfile = BFile.BFile(fpath, B_READ_WRITE | B_CREATE_FILE | B_FAIL_IF_EXISTS)
		bnode = BNode.BNode(fpath)
		bnodeinfo = BNodeInfo.BNodeInfo(bnode)
		bnodeinfo.SetType('application/x-person')
		bnode.WriteAttr('Jabber:JID', B_STRING_TYPE,0,'%s\0' % jid)
		bnode.WriteAttr('META:name', B_STRING_TYPE,0,'%s\0' % name)

def merge(jid, ref):
	bnode = BNode.BNode(ref)
	try:
		attrinfo = bnode.GetAttrInfo('Jabber:JID')
		oldjid = bnode.ReadAttr('Jabber:JID',0,0,attrinfo[1]-1)
	except BNode.error:
		bnode.WriteAttr('Jabber:JID', B_STRING_TYPE,0,'%s\0' % jid)
	else:
		alert = BAlert.BAlert('merge prompt', 'Contact already have a Jabber ID: %s.\nChange it to %s?' % (oldjid, jid), 'Yes', 'No', None, None, B_WARNING_ALERT)
		btn = alert.Go()
		if btn == 0:
			bnode.WriteAttr('Jabber:JID', B_STRING_TYPE,0,'%s\0' % jid)
