"""Configuration tools"""
import ConfigParser
import os

#_conf = ConfigParser.ConfigParser()
#_conf.read(os.path.expanduser('~/config/settings/Hermod/Preferences'))

#_acc = ConfigParser.ConfigParser()
#_acc.read(os.path.expanduser('~/config/settings/Hermod/Accounts'))

###########
### Classes
###########
class Config(ConfigParser.ConfigParser):
	def __init__(self):
		ConfigParser.ConfigParser.__init__(self)

	def get(self, section, value, default=None):
		try:
			return ConfigParser.ConfigParser.get(self, section, value)
		except ConfigParser.Error:
			return default

#	def read(self, filenames):
#		pass

	def getint(self, section, value, default=None):
		try:
			return ConfigParser.ConfigParser.getint(self, section, value)
		except (ConfigParser.Error,TypeError, ValueError):
			return default

	def getboolean(self, section, value, default=False):
		try:
			return ConfigParser.ConfigParser.getboolean(self,section, value)
		except ConfigParser.Error:
			return default
		# wth?
		except AttributeError:
			return default

	def sections(self, default=None):
		try:
			return ConfigParser.ConfigParser.sections(self)
		except ConfigParser.Error:
			return default

	def options(self, section, default=None):
		try:
			return ConfigParser.ConfigParser.options(self,section)
		except ConfigParser.Error:
			return default


class Configuration(Config):
	def __init__(self):
		Config.__init__(self)
		self.read(os.path.expanduser('~/config/settings/Hermod/Preferences'))

	def write(self):
		sfile = file(os.path.expanduser('~/config/settings/Hermod/Preferences'), 'w')
		Config.write(self, sfile)

class Accounts(Config):
	def __init__(self):
		Config.__init__(self)
		#self.conf = _acc
		self.read(os.path.expanduser('~/config/settings/Hermod/Accounts'))

	def write(self):
		sfile = file(os.path.expanduser('~/config/settings/Hermod/Accounts'), 'w')
		Config.write(self, sfile)

	def getAccounts(self):
		return self.sections([])

class Account:
	def __init__(self, id):
		conf = Accounts()
		(self.user, self.host) = id.split('@')
		self.port = conf.getint(id, 'port', 5222)
		self.password = conf.get(id, 'password', None)
		self.name = conf.get(id, 'name', '<Unnamed>')
		self.resource = conf.get(id, 'resource', 'Hermod')
		self.priority = conf.getint(id, 'priority', 0)
		self.ssl = conf.getboolean(id, 'ssl', False)
