//  This simple program is compile-linked to the Python interpreter,
//  so it can provide a "binary" image for the Python program it really
//  runs, and all kinds of BeOS loading semantics can be attached here -
//  mime types, icons, single-launch, bla bla.  This example is the most
//  minimal, crude but reasonably effective.
//
//  It's also possible to implement BApplication in C++ here, then import
//  the main Python module (now rewritten of course to omit its BApplication
//  class wrapper) and call its exported  methods.  I don't see anything
//  to be gained from this, but there's a lot I don't know.  Anyway, to do
//  it you need to add a tweak to BApplication.cpp, to set "be_app" from
//  the FromBApplication() function.

#include <sys/file.h>
#include <stdio.h>
#include <unistd.h>

#include <Entry.h>
#include <Path.h>

#ifndef PYTHON_INSTALL_PREFIX
#define PYTHON_INSTALL_PREFIX "/boot/home/config"
#endif

#include <Python.h>

static void
setup_interpreter(int argc, char **argv, char *appdir)
{
	char path[256];
	static const char prefix[] = PYTHON_INSTALL_PREFIX;
	char python[12];
	BPath progpath;
	BEntry entry(argv[0], false);

	entry.GetParent(&entry);
	entry.GetPath(&progpath);

	Py_SetProgramName(argv[0]);
	Py_Initialize();
	PySys_SetArgv(argc, argv);

	sprintf(python, "python%d.%d", PY_MAJOR_VERSION, PY_MINOR_VERSION);
	sprintf(path, "%s:%s/lib/%s:%s/lib/%s/plat-beos5:%s/lib/%s/lib-dynload",
		appdir,
		prefix, python,
		prefix, python,
		prefix, python);
		sprintf(path, "%s:%s/lib/%s/site-packages:%s", path, prefix, python, progpath.Path());
	PySys_SetPath(path);
}

int
main(int argc, char **argv)
{
	FILE *py;
	char *nm;
	BPath path;
	BEntry entry(argv[0], false);
	entry.GetParent(&entry);
	entry.GetPath(&path);
	char progfile[B_FILE_NAME_LENGTH];
	static char defdir[] = ".";
	char *progbase, *progdir;
	static char progname[] = APPNAME;

	// God only knows why it has to be like this for path's with spaces...
	chdir(path.Path());
	//sprintf(progfile, "%s/apps/%s/main.py", path.Path(), progname);
	sprintf(progfile, "./apps/%s/main.py", progname);

	py = fopen(progfile, "r");
	if (!py) {
		perror(progfile);
		exit(1);
	}

	progbase = strrchr(progfile, '/');
	if (progbase) {
		*progbase++ = 0;
		progdir = progfile;
	} else {
		progbase = progfile;
		progdir = defdir;
	}

	setup_interpreter(argc, argv, progfile);

	PyRun_SimpleFile(py, progbase);
	if (PyErr_Occurred()) {
		PyErr_Print();
		exit(1);
	} else
		exit(0);
}
